
' fcompare       zwei Dateien via FC vergleichen
'
'                 2010, 2011   E. Riedel (ERCC)
'


Dim dir1, file1, file2

If Wscript.Arguments.Count Then
    file1 = Wscript.Arguments(0)
Else
    file1 = GetFileName(1, "")
End If

If file1 = "" Then
    MsgBox "Keine Datei ausgewhlt!",,"fcompare: Error"
Else
    dir1 = GetFilePath(file1)
    file2 = GetFileName(2, dir1)
    If file2 = "" Then
        MsgBox "Keine 2. Datei ausgewhlt!",,"fcompare: Error"
    Else
        Compare file1, file2
    End If
End If


Function GetFileName(nr, path)      ' Version 2

    Dim dlg, f, ws, x

    On Error Resume Next
    Set dlg = CreateObject("MSComDlg.CommonDialog")      ' Dateiauswahl-Dialog
    If Err Then
        Err.Clear
        x = True
        Set dlg = CreateObject("FileDlg.FileSelection")  ' alternativ
        If Err Then
            Err.Clear
            f = InputBox("Sorry, kein Dateiauswahl-Dialog ausfhrbar!" & vbLF & _
                "Bitte " & nr & ". Dateinamen eingeben: ", "fcompare: Dateien vergleichen")
            GetFileName = f
            Exit Function
        End If
    End If
    If path = "" Then
        Set ws = WScript.CreateObject("WScript.Shell")
        If Err Then
            Err.Clear
            f = ""
        Else
            f = ws.CurrentDirectory
        End If
    Else
        f = path
    End If
    dlg.DialogTitle = "fcompare: Dateiauswahl " & nr
    dlg.InitDir = f
    If Not x Then
        dlg.Filter = "Alle Dateien (*.*)|*.*|"
        dlg.FilterIndex = 1
        dlg.MaxFileSize = 256
        dlg.CancelError = False
        dlg.ShowOpen
    Else
        dlg.ShowDialog
    End If
    f = dlg.FileName

    GetFileName = f

End Function


Function GetFilePath(filespec)

    Dim fso, f

    On Error Resume Next
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set f = fso.GetFile(filespec)
    GetFilePath = f.Path 

End Function


Sub Compare(file1, file2)

    Dim ws, s, c

    On Error Resume Next
    Set ws = WScript.CreateObject("WScript.Shell")
    If Err Then
        MsgBox "Sorry, Shell konnte nicht aufgerufen werden!",,"fcompare: Error"
    Else
        s = Chr(34)
        c = "CMD.EXE /K " & s & "fc /B " & s & file1 & s & " " & s & file2 & s & s
        ws.Run c
    End If

End Sub

